UNIT MainUnit1;

INTERFACE

USES
    Windows,
    Messages,
    SysUtils,
    Classes,
    Graphics,
    Controls,
    Forms,
    Dialogs,
    ExtCtrls,
    ComCtrls,
    StdCtrls,
    Menus,
    Mask,
    Buttons,
    ShellAPI,
    ImgList,
    inifiles,
    Grids,
    comobj,
    HLink,
    aregistry;

CONST
    SC_ABOUT=WM_USER+666;
    SC_MYHELP=WM_USER+666+1;
    SC_MYLICENSE=WM_USER+666+2;
    mydir='\Software\Assarbad';
TYPE
    TForm1=CLASS(TForm)
        MainMenu1:TMainMenu;
        File1:TMenuItem;
        Help1:TMenuItem;
        Exit1:TMenuItem;
        N1:TMenuItem;
        OpenProject1:TMenuItem;
        Help2:TMenuItem;
        N2:TMenuItem;
        About1:TMenuItem;
        CloseProject1:TMenuItem;
        Panel1:TPanel;
        ListBox1:TListBox;
        Panel2:TPanel;
        SpeedButton8:TSpeedButton;
        SpeedButton1:TSpeedButton;
        Panel3:TPanel;
        PageControl1:TPageControl;
        TabSheet1:TTabSheet;
        TabSheet2:TTabSheet;
        ImageList1:TImageList;
        License1:TMenuItem;
        Edit1:TEdit;
        AC:TLabel;
        Label13:TLabel;
        Edit2:TEdit;
        Label16:TLabel;
        Edit3:TEdit;
        Label19:TLabel;
        Edit4:TEdit;
        Label22:TLabel;
        Edit5:TEdit;
        Label25:TLabel;
        Label27:TLabel;
        Edit6:TEdit;
        Label28:TLabel;
        Label30:TLabel;
        Edit7:TEdit;
        Label31:TLabel;
        Edit8:TEdit;
        Label34:TLabel;
        Edit9:TEdit;
        Label40:TLabel;
        Label42:TLabel;
        Edit11:TEdit;
        Label43:TLabel;
        Label45:TLabel;
        Edit12:TEdit;
        Label46:TLabel;
        Label48:TLabel;
        Edit13:TEdit;
        Label49:TLabel;
        Label51:TLabel;
        Edit14:TEdit;
        Label52:TLabel;
        Label54:TLabel;
        Edit15:TEdit;
        Label55:TLabel;
        Label57:TLabel;
        Edit16:TEdit;
        Label10:TLabel;
        Label11:TLabel;
        Label12:TLabel;
        Label14:TLabel;
        Label15:TLabel;
        Label17:TLabel;
        Label18:TLabel;
        Label20:TLabel;
        Label21:TLabel;
        Label24:TLabel;
        Label26:TLabel;
        Label29:TLabel;
        Label32:TLabel;
        Label33:TLabel;
        Label35:TLabel;
        Label36:TLabel;
        Label67:TLabel;
        Label68:TLabel;
        Label23:TLabel;
        Label38:TLabel;
        Edit10:TEdit;
        Edit20:TEdit;
        Label39:TLabel;
        Edit21:TEdit;
        Label71:TLabel;
        Label73:TLabel;
        Label74:TLabel;
        Label90:TLabel;
        Label91:TLabel;
        Edit22:TEdit;
        Edit23:TEdit;
        Edit24:TEdit;
        StringGrid1:TStringGrid;
        Label37:TLabel;
        Edit17:TEdit;
        Label41:TLabel;
        Label44:TLabel;
        SpeedButton5:TSpeedButton;
        SpeedButton9:TSpeedButton;
        SpeedButton3:TSpeedButton;
        SpeedButton6:TSpeedButton;
        SpeedButton4:TSpeedButton;
        SpeedButton10:TSpeedButton;
        PROCEDURE FormCreate(Sender:TObject);
        PROCEDURE SpeedButton1Click(Sender:TObject);
        PROCEDURE About1Click(Sender:TObject);
        PROCEDURE Help2Click(Sender:TObject);
        PROCEDURE License1Click(Sender:TObject);
        PROCEDURE SpeedButton4Click(Sender:TObject);
        PROCEDURE Edit1KeyPress(Sender:TObject;VAR Key:Char);
        PROCEDURE Edit9KeyPress(Sender:TObject;VAR Key:Char);
        PROCEDURE SpeedButton6Click(Sender:TObject);
        PROCEDURE SpeedButton3Click(Sender:TObject);
        PROCEDURE SpeedButton8Click(Sender:TObject);
        PROCEDURE SpeedButton9Click(Sender:TObject);
        PROCEDURE FormCloseQuery(Sender:TObject;VAR CanClose:Boolean);
    PRIVATE
    { Private declarations }
    PUBLIC
        FUNCTION valid_input:boolean;
        PROCEDURE debugview(str:STRING);
        PROCEDURE Sysmsg(VAR msg:TMessage); MESSAGE WM_SYSCOMMAND;
    { Public declarations }
    END;

VAR
    Form1:TForm1;
    ininame:STRING;
    prjname:STRING;
    inifile:TINIFILE;
    allok, calcdata_there:boolean;
    helptext:STRING;
    hdlg:DWORD;
    excelfailed:boolean=false;

IMPLEMENTATION

USES mathunit,
    Savedlg,
    aresources,
    Opendlg,
    Graphunit;
{$R *.DFM}
{$R DLG.RES}

PROCEDURE Tform1.sysmsg(VAR msg:TMessage);
VAR
    h:DWORD;
BEGIN
    CASE msg.WParam OF
        SC_ABOUT:
            BEGIN
                ShowMessageBox(self.windowhandle, gettextfile('myabout')+#13#10#13#10#13#10+gettextfile('mycont'),appname);
            END;
        SC_MYHELP:
            BEGIN
                ShowMessageBox(self.windowhandle, gettextfile('myhelp')+#13#10#13#10#13#10+gettextfile('mycont'),appname);
            END;
        SC_MYLICENSE:
            BEGIN
                ShowMessageBox(self.windowhandle, gettextfile('mylic')+#13#10#13#10+gettextfile('specialnotes'),appname);
            END;
        SC_CLOSE:
            BEGIN
                IF excelfailed THEN BEGIN
                    h:=GetCurrentProcess;
                    TerminateProcess(h, $FF);
                END ELSE
                    close;
             //seems to be a bug ... thus KILL the process instead of closing
            END;
    END;
    INHERITED;
END;

FUNCTION Tform1.valid_input:boolean;
VAR
    dummy:double;
    zero_err, conv_err:boolean;
BEGIN
    zero_err:=false;
    conv_err:=false;
    TRY
        dummy:=strtofloat(edit1.text);
        IF dummy<>0 THEN
            mathunit.MAC:=dummy ELSE zero_err:=true;

    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit2.text);
        IF dummy<>0 THEN
            mathunit.H:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit3.text);
        IF dummy<>0 THEN
            mathunit.D:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit4.text);
        IF dummy<>0 THEN
            mathunit.dT:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit5.text);
        IF dummy<>0 THEN
            mathunit.M:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit6.text);
        IF dummy<>0 THEN
            mathunit.W0:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit7.text);
        IF dummy<>0 THEN
            mathunit.Xf:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit8.text);
        IF dummy<>0 THEN
            mathunit.A:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit9.text);
        IF dummy<>0 THEN
            mathunit.F:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    TRY
        dummy:=strtofloat(edit17.text);
        IF dummy<>0 THEN
            mathunit.U:=dummy ELSE zero_err:=true;
    EXCEPT ON EConverterror DO conv_err:=true;
    END;
    result:=(NOT zero_err)AND(NOT conv_err);
    IF NOT result{=if zero_err or conv_err then} THEN
        IF zero_err AND conv_err THEN
            messagebox(self.handle, pchar(invalid_non0f), pchar(general_error), MB_ICONERROR OR MB_OK)
        ELSE
            IF zero_err THEN
                messagebox(self.handle, pchar(invalid_non0), pchar(general_error), MB_ICONERROR OR MB_OK)
            ELSE
                IF conv_err THEN
                    messagebox(self.handle, pchar(invalid_f), pchar(general_error), MB_ICONERROR OR MB_OK)
                ELSE messagebox(self.handle, pchar(unknown_error), pchar(general_error), MB_ICONERROR OR MB_OK);
    IF NOT result THEN BEGIN
        pagecontrol1.ActivePage:=tabsheet1;
        activecontrol:=edit1;
    END;
END;

PROCEDURE Tform1.debugview(str:STRING);
BEGIN
    listbox1.Items.Append(timetostr(time)+' - '+str);
    listbox1.ItemIndex:=listbox1.Items.Count-1;
END;

PROCEDURE TForm1.FormCreate(Sender:TObject);
VAR
    hsysmenu:DWORD;
    secname:STRING;
    reg:Tregistry;
BEGIN
    Application.Title:=appname;
    hsysmenu:=GetSystemMenu(form1.WindowHandle, FALSE);
    IF hsysmenu<>0 THEN BEGIN
        DeleteMenu(hsysmenu, SC_MAXIMIZE, MF_BYCOMMAND);
        DeleteMenu(hsysmenu, SC_RESTORE, MF_BYCOMMAND);
        DeleteMenu(hsysmenu, SC_SIZE, MF_BYCOMMAND);
        Appendmenu(hsysmenu, MF_SEPARATOR, 0, NIL);
        Appendmenu(hsysmenu, MF_BYCOMMAND, SC_MYHELP, pchar(WSC_Help));
        Appendmenu(hsysmenu, MF_BYCOMMAND, SC_MYLICENSE, pchar(WSC_License));
        Appendmenu(hsysmenu, MF_SEPARATOR, 0, NIL);
        Appendmenu(hsysmenu, MF_BYCOMMAND, SC_ABOUT, pchar(WSC_about));
    END;
    caption:=appname;
    ininame:=extractfilename(application.ExeName);
    delete(ininame, length(ininame)-3, 4);
    prjname:='.\'+ininame+'.PRJ';
    debugview(format(Welcometo, [appname]));
    init_pgm_ctrls;
    pagecontrol1.ActivePage:=tabsheet1;
    activecontrol:=edit1;
    reg:=tregistry.Create;
    secname:='';
    IF reg.OpenKey(mydir, false, aregistry.R) THEN
        secname:=reg.ReadString('kovrov.prj');
    reg.Free;
    inifile:=tinifile.create(prjname);
    TRY
        IF inifile.SectionExists(secname) THEN BEGIN
            edit1.text:=inifile.ReadString(secname, 'val_MAC', '0');
            edit2.text:=inifile.ReadString(secname, 'val_H', '0');
            edit3.text:=inifile.ReadString(secname, 'val_D', '0');
            edit4.text:=inifile.ReadString(secname, 'val_dT', '0');
            edit5.text:=inifile.ReadString(secname, 'val_M', '0');
            edit6.text:=inifile.ReadString(secname, 'val_W0', '0');
            edit7.text:=inifile.ReadString(secname, 'val_Xf', '0');
            edit8.text:=inifile.ReadString(secname, 'val_A', '0');
            edit9.text:=inifile.ReadString(secname, 'val_F', '0');
            edit17.text:=inifile.ReadString(secname, 'val_U', '0');
            debugview(format(lasttime, [secname]));
        END;
    EXCEPT ON exception DO ;
    END;
    inifile.Free;

END;

PROCEDURE TForm1.SpeedButton1Click(Sender:TObject);
BEGIN
    sendmessage(self.windowhandle, WM_SYSCOMMAND, SC_CLOSE, 0);
END;

PROCEDURE TForm1.About1Click(Sender:TObject);
BEGIN
    sendmessage(form1.windowhandle, WM_SYSCOMMAND, SC_ABOUT, 0);
END;

PROCEDURE TForm1.Help2Click(Sender:TObject);
BEGIN
    sendmessage(form1.windowhandle, WM_SYSCOMMAND, SC_MYHELP, 0);
END;

PROCEDURE TForm1.License1Click(Sender:TObject);
BEGIN
    sendmessage(form1.windowhandle, WM_SYSCOMMAND, SC_MYLICENSE, 0);
END;

PROCEDURE TForm1.SpeedButton4Click(Sender:TObject);
VAR
    x:integer;
    entered:boolean;
BEGIN
    IF NOT valid_input THEN exit;
    debugview(dbg_startcalc);
     //start it
    calc_undependend;
    entered:=false;
    x:=0;
    WHILE true DO BEGIN
        setlength(dataarea, x+1);
        FRM_C(x);
        dataarea[x]:=mathunit.C;
        inc(x, 1);
        IF entered THEN BEGIN
            IF mathunit.C<mathunit.MAC THEN break
        END ELSE
            IF mathunit.C>mathunit.MAC THEN entered:=true;

    END;

     //finish it
    debugview(format(dbg_endcalc, [length(dataarea)]));
    edit10.text:=floattostr(mathunit.Cm);
    edit11.text:=floattostr(mathunit.Cmn);
    edit12.text:=floattostr(mathunit.Xm);
    edit13.text:=floattostr(mathunit.Xmn);
    edit14.text:=floattostr(mathunit.Vm);
    edit15.text:=floattostr(mathunit.V1);
    edit16.text:=floattostr(mathunit.Hm);
    edit20.text:=floattostr(mathunit.MTO);
    edit21.text:=floattostr(mathunit.Um);
    edit22.text:=floattostr(mathunit.f2);
    edit23.text:=floattostr(mathunit.m2);
    edit24.text:=floattostr(mathunit.n);
    debugview(dbg_starttabl);
    stringgrid1.RowCount:=length(dataarea);
    stringgrid1.Rows[0][0]:=distconc;
    stringgrid1.Rows[0][1]:=concin;
    FOR x:=1 TO length(dataarea)-1 DO BEGIN
        stringgrid1.Cols[0][x]:=format(dist, [x]);
        ;
        stringgrid1.Cols[1][x]:=floattostr(dataarea[x]);
    END;
    debugview(dbg_endtabl);
    tabsheet2.TabVisible:=true;
    speedbutton8.enabled:=true;
    pagecontrol1.ActivePage:=tabsheet2;
    activecontrol:=edit10;
    calcdata_there:=true;
END;

PROCEDURE TForm1.Edit1KeyPress(Sender:TObject;VAR Key:Char);
BEGIN
    IF key IN [#13, #10] THEN
        PostMessage(Handle, WM_NextDlgCtl, 0, 0)
    ELSE
        IF key IN ['.', ','] THEN BEGIN

        END ELSE
            IF key IN ['0'..'9', #8] THEN ELSE key:=#0;
END;

PROCEDURE TForm1.Edit9KeyPress(Sender:TObject;VAR Key:Char);
BEGIN
    IF key IN [#13, #10] THEN
        SpeedButton4Click(Sender)
    ELSE
        IF key IN ['.', ','] THEN BEGIN

        END ELSE
            IF key IN ['0'..'9', #8] THEN ELSE key:=#0;
END;

PROCEDURE TForm1.SpeedButton6Click(Sender:TObject);
BEGIN
    form6:=tform6.create(self);
    form6.showmodal;
    form6.free;
END;

PROCEDURE TForm1.SpeedButton3Click(Sender:TObject);
BEGIN
    form7:=tform7.create(self);
    form7.showmodal;
    form7.free;
END;

PROCEDURE TForm1.SpeedButton8Click(Sender:TObject);
BEGIN
    IF NOT calcdata_there THEN
        SpeedButton4Click(Sender);
    IF calcdata_there THEN BEGIN
        form8:=tform8.create(self);
        form8.showmodal;
        form8.free;
    END;
END;

PROCEDURE TForm1.SpeedButton9Click(Sender:TObject);

    PROCEDURE excelexport;
    VAR
        Excel:Variant;
        i:integer;
        excelran, excelvis:boolean;

    BEGIN
        allok:=false;
        screen.Cursor:=crHourglass;
        excelran:=true;
        TRY
            Excel:=GetActiveOleObject(exceltag);
        EXCEPT BEGIN
                TRY
                    Excel:=CreateOleObject(exceltag);
                EXCEPT
                    ShowMessage(no_excel);
                    screen.Cursor:=crdefault;
                    excelfailed:=true;
                    exit;
                END;
                excelran:=false;
            END;
        END;
        excelvis:=excel.visible;
        excel.visible:=false;
        TRY
      //create
            debugview(dbg_startexp);
            Excel.Workbooks.Add;
            TRY
      //fill
//Cells[y,x]!!!
                excel.Cells[1, 1].Value:=outputof+appname;

                excel.Cells[3, 2].Value:=mathunit.MAC;
                excel.Cells[4, 2].Value:=mathunit.H;
                excel.Cells[5, 2].Value:=mathunit.D;
                excel.Cells[6, 2].Value:=mathunit.dT;
                excel.Cells[7, 2].Value:=mathunit.M;
                excel.Cells[8, 2].Value:=mathunit.W0;
                excel.Cells[9, 2].Value:=mathunit.Xf;
                excel.Cells[10, 2].Value:=mathunit.A;
                excel.Cells[11, 2].Value:=mathunit.F;
                excel.Cells[12, 2].Value:=mathunit.U;
                excel.Cells[13, 2].Value:=mathunit.A;

                excel.Cells[15, 2].Value:=mathunit.Cm;
                excel.Cells[16, 2].Value:=mathunit.Cmn;
                excel.Cells[17, 2].Value:=mathunit.Xm;
                excel.Cells[18, 2].Value:=mathunit.Xmn;
                excel.Cells[19, 2].Value:=mathunit.Vm;
                excel.Cells[20, 2].Value:=mathunit.V1;
                excel.Cells[21, 2].Value:=mathunit.Um;
                excel.Cells[22, 2].Value:=mathunit.d2;
                excel.Cells[23, 2].Value:=mathunit.m2;
                excel.Cells[24, 2].Value:=mathunit.f2;
                excel.Cells[25, 2].Value:=mathunit.n;
                excel.Cells[26, 2].Value:=mathunit.Hm;
                excel.Cells[27, 2].Value:=mathunit.MTO;

                excel.Cells[3, 1].Value:=text_MAC;
                excel.Cells[4, 1].Value:=text_H;
                excel.Cells[5, 1].Value:=text_D;
                excel.Cells[6, 1].Value:=text_dT;
                excel.Cells[7, 1].Value:=text_M;
                excel.Cells[8, 1].Value:=text_W0;
                excel.Cells[9, 1].Value:=text_Xf;
                excel.Cells[10, 1].Value:=text_A;
                excel.Cells[11, 1].Value:=text_F;
                excel.Cells[12, 1].Value:=text_U;

                excel.Cells[15, 1].Value:=rMCW;
                excel.Cells[16, 1].Value:=rMC;
                excel.Cells[17, 1].Value:=rDistW;
                excel.Cells[18, 1].Value:=rDist;
                excel.Cells[19, 1].Value:=rPVm;
                excel.Cells[20, 1].Value:=rPV1;
                excel.Cells[21, 1].Value:=rPdU;
                excel.Cells[22, 1].Value:=rPd;
                excel.Cells[23, 1].Value:=rPm;
                excel.Cells[24, 1].Value:=rPf;
                excel.Cells[25, 1].Value:=rPn;
                excel.Cells[26, 1].Value:=rMHT;
                excel.Cells[27, 1].Value:=rMTO;
//Cells[y,x]!!!
                excel.Cells[30, 1].Value:=dist_from_source;
                excel.Cells[30, 2].Value:=conc_at_Y;

                FOR i:=1 TO length(dataarea)-1 DO BEGIN
                    application.ProcessMessages;
                    excel.Cells[31+i, 1].Value:=i;
                    excel.Cells[31+i, 2].Value:=dataarea[i];
                END;

                excel.activeworkbook.close;
            EXCEPT ON EOlesyserror DO
                    Showmessage(ole_error);
            END;
        FINALLY
      //save
      //close etc pp
            excel.visible:=excelvis;
            IF NOT excelran THEN excel.quit;
            excel:=unassigned;
        END;
        screen.Cursor:=crdefault;
        debugview(dbg_endexp);
        allok:=true;
    END;
BEGIN
    IF messagedlg(excel_note, mtconfirmation, [mbyes, mbno], 0)=mryes THEN excelexport;
END;

PROCEDURE TForm1.FormCloseQuery(Sender:TObject;VAR CanClose:Boolean);
BEGIN
    IF allok THEN canclose:=true ELSE canclose:=false;
END;

INITIALIZATION
    calcdata_there:=false;
    allok:=true;
END.
