UNIT aresources;
INTERFACE
USES windows,
    messages;

{$INCLUDE kovrov_string.pas}

//type definition
TYPE
    exefileinfo=RECORD
        Comments:STRING;
        CompanyName:STRING;
        FileDescription:STRING;
        FileVersion:STRING;
        InternalName:STRING;
        LegalCopyright:STRING;
        OriginalFilename:STRING;
        ProductName:STRING;
        ProductVersion:STRING;
    END;

{$R fileinfo.res}

VAR
    MAINMENU:DWORD=0;
    efinfo:exefileinfo;
    langID:integer;
    appname:STRING;

PROCEDURE init_pgm_ctrls;

IMPLEMENTATION
USES mainunit1;
VAR
    i:integer;
    dpchar:pchar;


PROCEDURE init_pgm_ctrls;
BEGIN
    WITH form1 DO BEGIN
        SpeedButton9.caption:=excel_exp;
        Label40.caption:=result_1_1;
        Label42.caption:=result_1_1l;
        Label43.caption:=result_1_2;
        Label45.caption:=result_1_2l;
        Label46.caption:=result_1_3;
        Label48.caption:=result_1_3l;
        Label49.caption:=result_1_4;
        Label51.caption:=result_1_4l;
        Label52.caption:=result_1_5;
        Label54.caption:=result_1_5l;
        Label55.caption:=result_1_6;
        Label57.caption:=result_1_6l;
        Label23.caption:=result_2_1;
        Label38.caption:=result_2_1l;
        Label39.caption:=result_2_2;
        Label71.caption:=result_2_3;
        Label73.caption:=result_2_3l;
        Label74.caption:=result_2_4;
        Label91.caption:=result_2_5;
        Label90.caption:=result_2_6;
        Label10.caption:=text_MAC;
        Label11.caption:=text_H;
        Label12.caption:=text_D;
        Label14.caption:=text_dT;
        Label15.caption:=text_M;
        Label17.caption:=text_W0;
        Label18.caption:=text_Xf;
        Label20.caption:=text_A;
        Label21.caption:=text_F;
        Label44.caption:=text_U;
        AC.caption:=sym_MAC;
        Label13.caption:=sym_H;
        Label16.caption:=sym_D;
        Label19.caption:=sym_dT;
        Label22.caption:=sym_M;
        Label25.caption:=sym_W0;
        Label27.caption:=sym_W0l;
        Label28.caption:=sym_Xf;
        Label30.caption:=sym_Xfl;
        Label31.caption:=sym_A;
        Label34.caption:=sym_F;
        Label37.caption:=sym_U;
        Label24.caption:=mg_per_m3;
        Label26.caption:=meter;
        Label29.caption:=meter;
        Label32.caption:=kelvin;
        Label33.caption:=g_per_s;
        Label35.caption:=m_per_s;
        Label41.caption:=m_per_s;
        Label36.caption:=percent;
        Label67.caption:=coeff_dim;
        Label68.caption:=non_dim;

          //menu
        File1.caption:=file_main;
        OpenProject1.caption:=file_open;
        CloseProject1.caption:=file_save;
        Exit1.caption:=file_exit;
        Help1.caption:=help_main;
        Help2.caption:=help_help;
        License1.caption:=help_license;
        About1.caption:=help_about;

          //panel menu
        SpeedButton4.caption:=p_openprj;
        SpeedButton10.caption:=p_saveprj;
        SpeedButton5.caption:=p_calc;
        SpeedButton8.caption:=p_graph;
        SpeedButton1.caption:=p_close;

        tabsheet1.caption:=page1;
        tabsheet2.caption:=page2;

    END;
END;

PROCEDURE getfileinfo;
//partially taken from a non-copyrighted(!) code snippet by Nico Bendlin
VAR
    pfileinfo:pointer;
    afilename, pvarfinfo,
        avarfpath:pchar;
    pdwhandle, ninfosize,
        nvarfinfo:DWORD;
    part_name:STRING;
BEGIN
    getmem(afilename, MAX_PATH+2);
    getmodulefilename(0, afilename, MAX_PATH);
    pdwhandle:=0;
    ninfosize:=getfileversioninfosize(afilename, pdwhandle);
    IF ninfosize<>0 THEN pfileinfo:=getmemory(ninfosize) ELSE pfileinfo:=NIL;
    IF assigned(pfileinfo) THEN
    TRY
        IF getfileversioninfo(afilename, pdwhandle, ninfosize, pfileinfo) THEN BEGIN
//this defines english as the standard language
            avarfpath:='\StringFileInfo\040904b0\';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='Comments';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.Comments:=STRING(pvarfinfo) ELSE efinfo.Comments:='';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='CompanyName';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.CompanyName:=STRING(pvarfinfo) ELSE efinfo.CompanyName:='';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='FileDescription';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.FileDescription:=STRING(pvarfinfo) ELSE efinfo.FileDescription:='';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='FileVersion';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.FileVersion:=STRING(pvarfinfo) ELSE efinfo.FileVersion:='';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='InternalName';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.InternalName:=STRING(pvarfinfo) ELSE efinfo.InternalName:='';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='LegalCopyright';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.LegalCopyright:=STRING(pvarfinfo) ELSE efinfo.LegalCopyright:='';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='OriginalFilename';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.OriginalFilename:=STRING(pvarfinfo) ELSE efinfo.OriginalFilename:='';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='ProductName';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.ProductName:=STRING(pvarfinfo) ELSE efinfo.ProductName:='';

            pvarfinfo:='';
            nvarfinfo:=0;
            part_name:='ProductVersion';
            IF verqueryvalue(pfileinfo, pchar(avarfpath+part_name), pointer(pvarfinfo), nvarfinfo) THEN
                efinfo.ProductVersion:=STRING(pvarfinfo) ELSE efinfo.ProductVersion:='';

        END;
    FINALLY
        freememory(pfileinfo);
        freemem(afilename, MAX_PATH+2);
    END;
END;

INITIALIZATION
    getfileinfo;
    appname:=efinfo.ProductName+' '+efinfo.ProductVersion+' - '+efinfo.LegalCopyright;
FINALIZATION

END.
